searchData={"items":[{"type":"module","doc":"This is an example on how to use `Nexus` with an\nescript application.\n\nAfter defined `:escript` entry into your `project/0` function\non `mix.exs` and set the `main_module` option, you can safely\ndefine your commands as usual with `defcommand/2`, CLI config\nand handlers.\n\nThen you need to call `parse/0` macro, which will inject both\n`parse/1` and `run/1` function, which the latter you can delegate\nfrom the `main/1` escript funciton, as can seen below.","title":"Escript.Example","ref":"Escript.Example.html"},{"type":"function","doc":"Prints CLI documentation based into the CLI spec defined given a command path\n\nFor more information, check `Nexus.CLI.Help`\n\nIt receives an optional command path, for displaying\nsubcommands help, for example","title":"Escript.Example.display_help/1","ref":"Escript.Example.html#display_help/1"},{"type":"function","doc":"iex> Escript.Example.display_help()\n    # prints help for the CLI itself showing all available commands and flags\n    :ok\n\n    iex> Escript.Example.display_help([:root])\n    # prints help for the `root` cmd showing all available subcommands and flags\n    :ok\n\n    iex> Escript.Example.display_help([:root, :nested])\n    # prints help for the `root -> :nested` subcmd showing all available subcommands and flags\n    :ok","title":"Examples - Escript.Example.display_help/1","ref":"Escript.Example.html#display_help/1-examples"},{"type":"function","doc":"Given the system `argv`, tries to parse the input\nand dispatches the parsed command to the handler\nmodule (aka `Elixir.Escript.Example`)\n\nIf it fails it will display the CLI help. This\nconvenience function can be used as delegated\nof an `Escript` or `Mix.Task` module\n\nFor more information chekc `Nexus.CLI.__run_cli__/2`","title":"Escript.Example.execute/1","ref":"Escript.Example.html#execute/1"},{"type":"function","doc":"","title":"Escript.Example.main/1","ref":"Escript.Example.html#main/1"},{"type":"task","doc":"This is a Mix Task example using Nexus.\nBasically, you can `use` both `Mix.Task` and `Nexus.CLI`\nmodules, define your commands as usual with `defcommand/2`\nand implement others callbacks.\n\nIn a `Mix.Task` module, the `run/1` function will supply\nthe behaviour, so you don't need to define it yourself.\n\nIf you need to do other computations inside `Mix.Task.run/1`,\nthen simply define `run/1` by yourself and call `__MODULE__.run/1`\nwhen you need it, passing the raw args to it.","title":"mix example","ref":"Mix.Tasks.Example.html"},{"type":"function","doc":"Prints CLI documentation based into the CLI spec defined given a command path\n\nFor more information, check `Nexus.CLI.Help`\n\nIt receives an optional command path, for displaying\nsubcommands help, for example","title":"Mix.Tasks.Example.display_help/1","ref":"Mix.Tasks.Example.html#display_help/1"},{"type":"function","doc":"iex> Mix.Tasks.Example.display_help()\n    # prints help for the CLI itself showing all available commands and flags\n    :ok\n\n    iex> Mix.Tasks.Example.display_help([:root])\n    # prints help for the `root` cmd showing all available subcommands and flags\n    :ok\n\n    iex> Mix.Tasks.Example.display_help([:root, :nested])\n    # prints help for the `root -> :nested` subcmd showing all available subcommands and flags\n    :ok","title":"Examples - Mix.Tasks.Example.display_help/1","ref":"Mix.Tasks.Example.html#display_help/1-examples"},{"type":"function","doc":"Given the system `argv`, tries to parse the input\nand dispatches the parsed command to the handler\nmodule (aka `Elixir.Mix.Tasks.Example`)\n\nIf it fails it will display the CLI help. This\nconvenience function can be used as delegated\nof an `Escript` or `Mix.Task` module\n\nFor more information chekc `Nexus.CLI.__run_cli__/2`","title":"Mix.Tasks.Example.execute/1","ref":"Mix.Tasks.Example.html#execute/1"},{"type":"module","doc":"MyCLI provides file operations such as copy, move, and delete using the Nexus.CLI DSL.","title":"MyCLI","ref":"MyCLI.html"},{"type":"function","doc":"Prints CLI documentation based into the CLI spec defined given a command path\n\nFor more information, check `Nexus.CLI.Help`\n\nIt receives an optional command path, for displaying\nsubcommands help, for example","title":"MyCLI.display_help/1","ref":"MyCLI.html#display_help/1"},{"type":"function","doc":"iex> MyCLI.display_help()\n    # prints help for the CLI itself showing all available commands and flags\n    :ok\n\n    iex> MyCLI.display_help([:root])\n    # prints help for the `root` cmd showing all available subcommands and flags\n    :ok\n\n    iex> MyCLI.display_help([:root, :nested])\n    # prints help for the `root -> :nested` subcmd showing all available subcommands and flags\n    :ok","title":"Examples - MyCLI.display_help/1","ref":"MyCLI.html#display_help/1-examples"},{"type":"function","doc":"Given the system `argv`, tries to parse the input\nand dispatches the parsed command to the handler\nmodule (aka `Elixir.MyCLI`)\n\nIf it fails it will display the CLI help. This\nconvenience function can be used as delegated\nof an `Escript` or `Mix.Task` module\n\nFor more information chekc `Nexus.CLI.__run_cli__/2`","title":"MyCLI.execute/1","ref":"MyCLI.html#execute/1"},{"type":"module","doc":"Nexus is a comprehensive toolkit for building Command-Line Interfaces (CLI) and Terminal User Interfaces (TUI) in Elixir. It provides a unified framework that simplifies the development of interactive applications running in the terminal.","title":"Nexus","ref":"Nexus.html"},{"type":"module","doc":"The Nexus ecosystem is designed to be modular and extensible, comprising different namespaces to organize its functionalities:\n\n- `Nexus.CLI`: Tools and macros for building robust command-line interfaces.\n- `Nexus.TUI`: *(Upcoming)* A toolkit leveraging Phoenix LiveView and The Elm Architecture (TEA) to create rich terminal user interfaces.\n\nBy leveraging Elixir's strengths and integrating with powerful frameworks like Phoenix LiveView, Nexus aims to streamline the process of creating both CLIs and TUIs with minimal boilerplate and maximum flexibility.","title":"Overview - Nexus","ref":"Nexus.html#module-overview"},{"type":"module","doc":"- **Declarative Command Definitions**: Use expressive macros to define commands, subcommands, arguments, and flags in a clean and readable manner.\n- **Automatic Help Generation**: Automatically generate help messages and usage instructions based on your command definitions.\n- **Extensible Architecture**: Designed to be extended and integrated with other tools, making it adaptable to a wide range of applications.","title":"Features - Nexus","ref":"Nexus.html#module-features"},{"type":"module","doc":"To start using Nexus for building CLIs, add it as a dependency in your `mix.exs` file:\n\n```elixir\ndef deps do\n  [\n    {:nexus_cli, \"~> 0.5\"}\n  ]\nend\n```\n\nThen, create your CLI module:\n\n```elixir\ndefmodule MyCLI do\n  use Nexus.CLI, otp_app: :my_app\n\n  # no value root command\n  defcommand :version do\n    description \"Shows the program version\"\n  end\n\n  # nested subcommand\n  defcommand :file do\n    description \"Performs file operations such as copy, move, and delete.\"\n\n    # multi value nested subcommand\n    subcommand :copy do\n      description \"Copies files from source to destination.\"\n\n      value :string, required: true, as: :source\n      value :string, required: true, as: :dest\n\n      flag :verbose do\n        short :v\n        description \"Enables verbose output.\"\n      end\n\n      flag :recursive do\n        short :r\n        description \"Copies directories recursively.\"\n      end\n    end\n\n    # Define more subcommands as needed\n  end\n\n  @impl Nexus.CLI\n  def handle_input(:version, %{value: true}) do\n    # `version/1` is auto injected or you can define the callback yourself\n    IO.puts(version())\n  end\n\n  def handle_input([:file, :copy], %{args: args, flags: flags}) do\n    if flags[:verbose] do\n      IO.puts(\"Copying from #{args[:source]} to #{args[:dest]}...\")\n    end\n\n    with {:error, reason} <- do_copy(args) do\n      {:error, {1, reason}}\n    end\n  end\n\n  @spec do_copy(map) :: :ok | {:error, term}\n  defp do_copy(%{source: _, dest: _}) do\n    # Implement the copy logic here\n  end\nend\n```\n\nCheck `Nexus.CLI` module for more information about callbacks and function returns\n\n> Get started today and build amazing CLI and TUI applications with Nexus!","title":"Getting Started with Nexus - Nexus","ref":"Nexus.html#module-getting-started-with-nexus"},{"type":"behaviour","doc":"Nexus.CLI provides a macro-based DSL for defining command-line interfaces with commands,\nflags, and positional arguments using structured ASTs with structs.","title":"Nexus.CLI","ref":"Nexus.CLI.html"},{"type":"behaviour","doc":"The `Nexus.CLI` module allows you to build robust command-line applications by defining commands, subcommands, flags, and arguments using a declarative syntax. It handles parsing, validation, and dispatching of commands, so you can focus on implementing your application's logic.","title":"Overview - Nexus.CLI","ref":"Nexus.CLI.html#module-overview"},{"type":"behaviour","doc":"1. **Definition**: Use the provided macros (`defcommand`, `subcommand`, `flag`, `value`, etc.) to define your CLI's structure in a clear and organized way.\n2. **Compilation**: During compilation, Nexus processes your definitions, builds an abstract syntax tree (AST), and validates your commands and flags.\n3. **Parsing**: When your application runs, Nexus parses the user input (e.g., command-line arguments) against the defined AST, handling flags, arguments, and subcommands.\n4. **Dispatching**: After successful parsing, Nexus dispatches the command to your `handle_input/2` callback, passing the parsed input.\n5. **Execution**: You implement the `handle_input/2` function to perform the desired actions based on the command and input.","title":"Command Life Cycle - Nexus.CLI","ref":"Nexus.CLI.html#module-command-life-cycle"},{"type":"behaviour","doc":"The `handle_input/2` function is the core of your command's execution logic. It receives the command path and an `Nexus.CLI.Input` struct containing parsed flags and arguments.","title":"The `handle_input/2` Callback - Nexus.CLI","ref":"Nexus.CLI.html#module-the-handle_input-2-callback"},{"type":"behaviour","doc":"@callback handle_input(cmd :: atom | list(atom), input :: Input.t()) :: :ok | {:error, error}\n\n- `cmd`: The command or command path (list of atoms) representing the executed command or a single atom if no subcommand is provided.\n- `input`: An `%Nexus.CLI.Input{}` struct containing `flags`, `args`, and `value`.","title":"Signature - Nexus.CLI","ref":"Nexus.CLI.html#module-signature"},{"type":"behaviour","doc":"- `:ok`: Indicates successful execution. The application will exit with a success code (`0`).\n- `{:error, {code :: integer, reason :: String.t()}}`: Indicates an error occurred. The application will exit with the provided error code.","title":"Return Values - Nexus.CLI","ref":"Nexus.CLI.html#module-return-values"},{"type":"behaviour","doc":"You can run your CLI application using different methods:","title":"Running the CLI Application - Nexus.CLI","ref":"Nexus.CLI.html#module-running-the-cli-application"},{"type":"behaviour","doc":"If you're developing and testing your CLI, you can run it directly with `mix run`:\n\n    mix run -e 'MyCLI.execute(\"file copy source.txt dest.txt --verbose\")'","title":"Using `mix run` - Nexus.CLI","ref":"Nexus.CLI.html#module-using-mix-run"},{"type":"behaviour","doc":"Escript allows you to compile your application into a single executable script.\n\n**Steps:**\n\n1. **Add Escript Configuration**: In your `mix.exs`, add the `:escript` configuration:\n\n```elixir\ndef project do\n  [\n    app: :my_cli,\n    version: \"0.1.0\",\n    elixir: \"~> 1.12\",\n    escript: [main_module: MyCLI],\n    deps: deps()\n  ]\nend\n```\n\n2. **Build the Escript**:\n\n```sh\nmix escript.build\n```\n\n3. **Run the Executable**:\n\n```sh\n./my_cli file copy --verbose source.txt dest.txt\n```\n\n> Note that in order to use and distribute escript binaries, the host needs to have Erlang runtime available on $PATH","title":"Compiling with Escript - Nexus.CLI","ref":"Nexus.CLI.html#module-compiling-with-escript"},{"type":"behaviour","doc":"[Burrito](https://github.com/burrito-elixir/burrito) allows you to compile your application into a standalone binary.\n\n**Steps:**\n\n1. **Add Burrito Dependency**: Add Burrito to your `mix.exs`:\n\n```elixir\ndefp deps do\n  [\n    {:burrito, github: \"burrito-elixir/burrito\"}\n  ]\nend\n```\n\n2. **Configure Releases**: Update your `mix.exs` with Burrito release configuration:\n\n```elixir\ndef project do\n  [\n    app: :my_cli,\n    version: \"0.1.0\",\n    elixir: \"~> 1.12\",\n    releases: releases()\n  ]\nend\n\ndef releases do\n  [\n    my_cli: [\n      steps: [:assemble, &Burrito.wrap/1],\n      burrito: [\n        targets: [\n          macos: [os: :darwin, cpu: :x86_64],\n          linux: [os: :linux, cpu: :x86_64],\n          windows: [os: :windows, cpu: :x86_64]\n        ]\n      ]\n    ]\n  ]\nend\n```\n\n3. **Build the Release**:\n\n```sh\nMIX_ENV=prod mix release\n```\n\n4. **Run the Binary**:\n\n```sh\n./burrito_out/my_cli_macos file copy --verbose source.txt dest.txt\n```","title":"Compiling with Burrito - Nexus.CLI","ref":"Nexus.CLI.html#module-compiling-with-burrito"},{"type":"behaviour","doc":"You can also run your CLI as a Mix task.\n\n**Steps:**\n\n1. **Create a Mix Task Module**:\n\n```elixir\ndefmodule Mix.Tasks.MyCli do\n  use Mix.Task\n\n  @shortdoc \"Runs the MyCLI application\"\n\n  def run(args) do\n    MyCLI.execute(args)\n  end\nend\n```\n\n2. **Run the Task**:\n\n```sh\nmix my_cli file copy --verbose source.txt dest.txt\n```","title":"Using Mix Tasks - Nexus.CLI","ref":"Nexus.CLI.html#module-using-mix-tasks"},{"type":"behaviour","doc":"- **Version and Description**: By default, `version/0` and `description/0` callbacks fetch information from `mix.exs` and `@moduledoc`, respectively. You can override them if needed.\n- **Error Handling**: Use the `{:error, {code, reason}}` tuple to return errors from `handle_input/2`. The application will exit with the specified code, and the reason will be printed.","title":"Additional Information - Nexus.CLI","ref":"Nexus.CLI.html#module-additional-information"},{"type":"function","doc":"Given a the CLI spec and the user input,\ntries to parse the input against the spec and dispatches the\nparsed result to the CLI handler module - the one that imeplement `Nexus.CLI`\nbehaviour.\n\nIf the dispatchment is successfull and the `handle_input/2` return an `:ok`,\nthen it stops the VM with a success code.\n\nIf there is a parsing error it will display the CLI help and stop the VM with\nerror code.\n\nIf `handle_input/2` returns an error, it stops the VM with the desired code.","title":"Nexus.CLI.__run_cli__/2","ref":"Nexus.CLI.html#__run_cli__/2"},{"type":"callback","doc":"Custom banners can be set","title":"Nexus.CLI.banner/0","ref":"Nexus.CLI.html#c:banner/0"},{"type":"macro","doc":"Defines a top-level command for the CLI application.\n\nUse this macro to declare a new command along with its subcommands, arguments, and flags.","title":"Nexus.CLI.defcommand/2","ref":"Nexus.CLI.html#defcommand/2"},{"type":"macro","doc":"- `name` - The name of the command (an atom).\n  - `do: block` - A block containing the command's definitions.","title":"Parameters - Nexus.CLI.defcommand/2","ref":"Nexus.CLI.html#defcommand/2-parameters"},{"type":"macro","doc":"defcommand :my_command do\n      # Define subcommands, flags, and arguments here\n    end","title":"Examples - Nexus.CLI.defcommand/2","ref":"Nexus.CLI.html#defcommand/2-examples"},{"type":"callback","doc":"Sets the CLI description\n\nDefault implementation fetches from `@moduledoc`, however\ntake in account that if you're compiling your app as an escript\nor single binary (rg. burrito) the `@moduledoc` attribute may be\nnot available on runtime\n\nFetch module documentation on compile-time is marked to Elixir 2.0\ncheck https://github.com/elixir-lang/elixir/issues/8095","title":"Nexus.CLI.description/0","ref":"Nexus.CLI.html#c:description/0"},{"type":"macro","doc":"Sets the description for a command, subcommand, or flag.\n\nUse this macro within a `defcommand`, `subcommand`, or `flag` block to provide a description.","title":"Nexus.CLI.description/1","ref":"Nexus.CLI.html#description/1"},{"type":"macro","doc":"- `desc` - The description text (a string).","title":"Parameters - Nexus.CLI.description/1","ref":"Nexus.CLI.html#description/1-parameters"},{"type":"macro","doc":"defcommand :my_command do\n      description \"Performs the main operation.\"\n\n      flag :verbose do\n        description \"Enables verbose mode.\"\n      end\n    end","title":"Examples - Nexus.CLI.description/1","ref":"Nexus.CLI.html#description/1-examples"},{"type":"macro","doc":"Defines a flag (option) for a command or subcommand.\n\nUse this macro within a command or subcommand block to declare a new flag and its properties.\n\nFlags can have arguments too, therefore you can safely use the `value/2` macro inside of it.","title":"Nexus.CLI.flag/2","ref":"Nexus.CLI.html#flag/2"},{"type":"macro","doc":"- `name` - The name of the flag (an atom).\n  - `do: block` - A block containing the flag's definitions.","title":"Parameters - Nexus.CLI.flag/2","ref":"Nexus.CLI.html#flag/2-parameters"},{"type":"macro","doc":"defcommand :my_command do\n      flag :verbose do\n        short :v\n        description \"Enables verbose mode.\"\n      end\n    end","title":"Examples - Nexus.CLI.flag/2","ref":"Nexus.CLI.html#flag/2-examples"},{"type":"callback","doc":"Function that receives the current command being used and its args\n\nIf a subcommand is being used, then the first argument will be a list\nof atoms representing the command path\n\nNote that when returning `:ok` from this function, your program will\nexit with a success code, generally `0`\n\nTo inform errors, check the `Nexus.CLI.error()` type","title":"Nexus.CLI.handle_input/2","ref":"Nexus.CLI.html#c:handle_input/2"},{"type":"callback","doc":"@impl Nexus.CLI\n    def handle_input(:my_cmd, _), do: nil\n\n    def handle_inpu([:my, :nested, :cmd], _), do: nil","title":"Examples - Nexus.CLI.handle_input/2","ref":"Nexus.CLI.html#c:handle_input/2-examples"},{"type":"macro","doc":"Defines a short alias for a flag.\n\nUse this macro within a `flag` block to assign a short (single-letter) alias to a flag.","title":"Nexus.CLI.short/1","ref":"Nexus.CLI.html#short/1"},{"type":"macro","doc":"- `short_name` - The short alias for the flag (an atom).","title":"Parameters - Nexus.CLI.short/1","ref":"Nexus.CLI.html#short/1-parameters"},{"type":"macro","doc":"flag :verbose do\n      short :v\n      description \"Enables verbose mode.\"\n    end","title":"Examples - Nexus.CLI.short/1","ref":"Nexus.CLI.html#short/1-examples"},{"type":"macro","doc":"Defines a subcommand within the current command.\n\nUse this macro inside a `defcommand` or another `subcommand` block to define a nested subcommand.","title":"Nexus.CLI.subcommand/2","ref":"Nexus.CLI.html#subcommand/2"},{"type":"macro","doc":"- `name` - The name of the subcommand (an atom).\n  - `do: block` - A block containing the subcommand's definitions.","title":"Parameters - Nexus.CLI.subcommand/2","ref":"Nexus.CLI.html#subcommand/2-parameters"},{"type":"macro","doc":"defcommand :parent_command do\n      subcommand :child_command do\n        # Define subcommands, flags, and arguments here\n      end\n    end","title":"Examples - Nexus.CLI.subcommand/2","ref":"Nexus.CLI.html#subcommand/2-examples"},{"type":"macro","doc":"Defines a positional argument for a command or a flag.\n\nUse this macro to specify an argument's type and options within a command, subcommand, or flag block.","title":"Nexus.CLI.value/2","ref":"Nexus.CLI.html#value/2"},{"type":"macro","doc":"- `type` - The type of the argument (e.g., `:string`, `:integer`). Check `Nexus.CLI.value()` type\n  - `opts` - A keyword list of options (optional).","title":"Parameters - Nexus.CLI.value/2","ref":"Nexus.CLI.html#value/2-parameters"},{"type":"macro","doc":"- `:required` - Indicates if the argument is required (boolean).\n  - `:as` - The name of the argument (atom), required if multiple values are defined\n  otherwise the name will be the same of the command that it defined\n  - `:default` - Defines the default value if the argument is not provided","title":"Options - Nexus.CLI.value/2","ref":"Nexus.CLI.html#value/2-options"},{"type":"macro","doc":"defcommand :my_command do\n      value :string, required: true, as: :filename\n    end\n\n    flag :output do\n      value :string, required: true\n    end","title":"Examples - Nexus.CLI.value/2","ref":"Nexus.CLI.html#value/2-examples"},{"type":"callback","doc":"Sets the version of the CLI\n\nDefault implementation fetches from the `mix.exs`","title":"Nexus.CLI.version/0","ref":"Nexus.CLI.html#c:version/0"},{"type":"type","doc":"Represents the CLI spec, basically a list of `Command.t()` spec","title":"Nexus.CLI.ast/0","ref":"Nexus.CLI.html#t:ast/0"},{"type":"type","doc":"Represents an final-user error while executing a command\n\nNeed to inform the return code of the program and a reason of the error","title":"Nexus.CLI.error/0","ref":"Nexus.CLI.html#t:error/0"},{"type":"type","doc":"","title":"Nexus.CLI.t/0","ref":"Nexus.CLI.html#t:t/0"},{"type":"type","doc":"Represent all possible value types of an command argument or flag value","title":"Nexus.CLI.value/0","ref":"Nexus.CLI.html#t:value/0"},{"type":"module","doc":"Represents a positional argument for a command.","title":"Nexus.CLI.Argument","ref":"Nexus.CLI.Argument.html"},{"type":"type","doc":"","title":"Nexus.CLI.Argument.t/0","ref":"Nexus.CLI.Argument.html#t:t/0"},{"type":"module","doc":"Represents a command or subcommand.","title":"Nexus.CLI.Command","ref":"Nexus.CLI.Command.html"},{"type":"type","doc":"","title":"Nexus.CLI.Command.t/0","ref":"Nexus.CLI.Command.html#t:t/0"},{"type":"module","doc":"Dispatches parsed CLI commands to the appropriate handler functions.","title":"Nexus.CLI.Dispatcher","ref":"Nexus.CLI.Dispatcher.html"},{"type":"function","doc":"Dispatches the parsed command to the corresponding handler.\n\n- `module` is the module where the handler functions are defined.\n- `parsed` is the result from `Nexus.Parser.parse_ast/2`.","title":"Nexus.CLI.Dispatcher.dispatch/2","ref":"Nexus.CLI.Dispatcher.html#dispatch/2"},{"type":"module","doc":"Represents a flag (option) for a command.","title":"Nexus.CLI.Flag","ref":"Nexus.CLI.Flag.html"},{"type":"type","doc":"","title":"Nexus.CLI.Flag.t/0","ref":"Nexus.CLI.Flag.html#t:t/0"},{"type":"module","doc":"Provides functionality to display help messages based on the CLI AST.","title":"Nexus.CLI.Help","ref":"Nexus.CLI.Help.html"},{"type":"function","doc":"Displays help information for the given command path.\n\nIf no command path is provided, it displays the root help.","title":"Nexus.CLI.Help.display/2","ref":"Nexus.CLI.Help.html#display/2"},{"type":"module","doc":"Represents a command input, with args and flags values parsed\n\n- `flags` is a map with keys as flags names and values as flags values\n- `args` is a map of positional arguments where keys are the arguments\nnames defined with the `:as` option on the `value/2` macro\n- `value` is a single value term that represents the command value itself\n\nIf the command define multiple (positional) arguments, `value` will be `nil`\nand `args` willbe populated, otherwise `args` will be an empty map and `value`\nwill be populated","title":"Nexus.CLI.Input","ref":"Nexus.CLI.Input.html"},{"type":"type","doc":"","title":"Nexus.CLI.Input.t/0","ref":"Nexus.CLI.Input.html#t:t/0"},{"type":"module","doc":"Provides validation functions for commands, flags, and arguments within the Nexus.CLI DSL.","title":"Nexus.CLI.Validation","ref":"Nexus.CLI.Validation.html"},{"type":"function","doc":"Validates an argument.","title":"Nexus.CLI.Validation.validate_argument/1","ref":"Nexus.CLI.Validation.html#validate_argument/1"},{"type":"function","doc":"Validates a command, including its subcommands, flags, and arguments.","title":"Nexus.CLI.Validation.validate_command/1","ref":"Nexus.CLI.Validation.html#validate_command/1"},{"type":"function","doc":"Validates a flag.","title":"Nexus.CLI.Validation.validate_flag/1","ref":"Nexus.CLI.Validation.html#validate_flag/1"},{"type":"module","doc":"Nexus.Parser provides functionalities to parse raw input strings based on the CLI AST.\nThis implementation uses manual tokenization and parsing without parser combinators.","title":"Nexus.Parser","ref":"Nexus.Parser.html"},{"type":"function","doc":"Parses the raw input string based on the given AST.","title":"Nexus.Parser.parse_ast/2","ref":"Nexus.Parser.html#parse_ast/2"},{"type":"type","doc":"","title":"Nexus.Parser.result/0","ref":"Nexus.Parser.html#t:result/0"},{"type":"exception","doc":"","title":"Nexus.CLI.Validation.ValidationError","ref":"Nexus.CLI.Validation.ValidationError.html"},{"type":"extras","doc":"# Nexus\n\n```sh\n     _      __\n|\\ ||_\\/| |(_\n| \\||_/\\|_|__)\n```\n\n> Create CLIs in a magic and declarative way!\n\nAn `Elixir` library to write command line apps in a cleaner and elegant way!\n\n[![Hex.pm](https://img.shields.io/hexpm/v/nexus_cli.svg)](https://hex.pm/packages/nexus_cli)\n[![Downloads](https://img.shields.io/hexpm/dt/nexus_cli.svg)](https://hex.pm/packages/nexus_cli)\n[![Documentation](https://img.shields.io/badge/documentation-gray)](https://hexdocs.pm/nexus_cli)\n[![ci](https://github.com/zoedsoupe/nexus/actions/workflows/ci.yml/badge.svg)](https://github.com/zoedsoupe/nexus/actions/workflows/ci.yml)","title":"Nexus","ref":"readme.html"},{"type":"extras","doc":"Just add the `nexus_cli` package to your `mix.exs`\n\n```elixir\ndef deps do\n  [\n    {:nexus_cli, \"~> 0.5\"}\n  ]\nend\n```","title":"Installation - Nexus","ref":"readme.html#installation"},{"type":"extras","doc":"```elixir\ndefmodule MyCLI do\n  @moduledoc \"This will be used into as help\"\n\n  use Nexus.CLI\n\n  defcommand :fizzbuzz do\n    description \"Plays fizzbuzz - this will also be used as help\"\n\n    value :integer, required: true\n  end\n\n  @impl Nexus.CLI\n  def handle_input(:fizzbuzz, %{value: value}) when is_integer(value) do\n    cond do\n      rem(value, 3) == 0 and rem(value, 5) == 0 -> IO.puts(\"fizzbuzz\")\n      rem(value, 3) == 0 -> IO.puts(\"fizz\")\n      rem(value, 5) == 0 -> IO.puts(\"buzz\")\n      true -> IO.puts value\n    end\n  end\nend\n```\n\nMore different ways to use this library can be found on the [examples](./examples) folder\nDocumentation on defining a CLI module can be found at the [Nexus.CLI](https://hexdocs.pm/nexus_cli/Nexus.CLI.html)","title":"Example - Nexus","ref":"readme.html#example"},{"type":"extras","doc":"Nexus is a connection from two different worlds! This library connects the world of CLIs with the magic world of `Elixir`!","title":"Why \"Nexus\" - Nexus","ref":"readme.html#why-nexus"},{"type":"extras","doc":"Highly inspired in [clap-rs](https://github.com/clap-rs/clap/)","title":"Inspirations - Nexus","ref":"readme.html#inspirations"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}